Attribute VB_Name = "Module5"
  DefSng A-H
  DefSng U-Z
  Public Const M1& = 2147483563, M1Min1& = 2147483562, IA1& = 40014
  Public Const IQ1& = 53668, ir1& = 12211
  Public Const M2& = 2147483399, IA2& = 40692, IQ2& = 52774, ir2& = 2791
  Public Const XM1inv = 4.656613E-10
  Public iSeed1&, iSeed2&, iz&, ii
  Public RandNum#(1000), nZuf

Public Sub ECPreview(ByVal z As Variant)
  Dim ELXYa, ELXYb, ELXYc
  iTypQ = 1
  With Atom
    .EK = 0.016825 * z ^ 2 - 0.3701 * z + 5.34
    .eL = 0.003805 * z ^ 2 - 0.1416 * z + 1.94
    .EM = 0.00112 * z ^ 2 - 0.0532 * z + 0.71
    .EKL = 0.00617 * z ^ 2.12956: .EffKL = EffPhot(.EKL)
    .EKX = 0.00602 * z ^ 2.1676: .EffKX = EffPhot(.EKX)
    .ELX = 0.000243 * z ^ 2.447618: .EffLX = EffPhot(.ELX)
    .EKLL = 0.00704 * z ^ 2.04573: .EffKLL = EffElek(.EKLL)
    .EKLX = 0.0066 * z ^ 2.1034: .EffKLX = EffElek(.EKLX)
    .EKXY = 0.0065 * z ^ 2.1415: .EffKXY = EffElek(.EKXY)
    ELXYa = 0.0006212 * z ^ 2 + 0.025439 * z - 0.564
    ELXYb = 0.00099 * z ^ 2 - 0.0013 * z - 0.11 'Z=17-45
    ELXYc = 0.000235 * z ^ 2.361668 'Z>45
    If z > 45 Then .ELXY = ELXYc Else .ELXY = ELXYb
    .EffLXY = EffElek(.ELXY)
    .pK = -0.0000095 * z ^ 2 - 0.00054 * z + 0.90987
    .pL = 0.0000076 * z ^ 2 + 0.000154 * z + 0.0855
    .pM = 0.00038 * z + 0.00488
    .pN = 0.00016 * z - 0.0033
    .nKL = -0.0000036714 * z ^ 3 + 0.00087327 * z ^ 2 - 0.0702606 * z + 2.728011
    .pKL = 0.00002005 * z ^ 2 - 0.0039278 * z + 0.96684
    .pKX = 1 - .pKL
    .pKLL = 0.00003751 * z ^ 2 - 0.0069895 * z + 0.929108
    .pKLX = -0.00003327 * z ^ 2 + 0.005928 * z + 0.08093
    .pKXY = -0.00000408 * z ^ 2 + 0.0010468 * z - 0.00969
    If z > 19 Then .wK = 0.0000037 * z ^ 3 - 0.000881 * z ^ 2 + 0.070227 * z - 0.91801 Else .wK = 0
    If z > 25 Then .wL = 0.00010903 * z ^ 2 - 0.0051569 * z + 0.06286 Else .wL = 0
  End With
  Eff1 = 0.000000063 * z ^ 6 - 0.0000197716 * z ^ 5 + 0.00239479 * z ^ 4 - 0.1393109 * z ^ 3 + 3.90966 * z ^ 2 - 45.07626 * z + 155.3
  Eff2 = 0.0000000707 * z ^ 6 - 0.0000232744 * z ^ 5 + 0.00301217 * z ^ 4 - 0.1928168 * z ^ 3 + 6.29121 * z ^ 2 - 95.96502 * z + 544.9
  unc = 100
  If z < 41 Then
    unc = 0.0015587 * z ^ 2 - 0.10046 * z + 1.9309
  Else
    unc = -0.00000011249 * z ^ 5 + 0.000039242 * z ^ 4 - 0.0053059 * z ^ 3 + 0.34542 * z ^ 2 - 10.758 * z + 128.72
  End If
  
End Sub

Public Function Ex(ByVal xArg)
' EX COMPUTES EXP FUNCTIONS WITH LARGE ARGUMENTS
  If xArg < -10 Then Ex = 0 Else Ex = Exp(xArg)
End Function

Public Function fnPol(ByVal x)
  Dim i, y
  y = 0
  For i = 0 To QuenchDat(ikb).grad
    y = y + QuenchDat(ikb).PolKoeff(i) * x ^ i
  Next: fnPol = y
End Function

Sub PolFit()
Dim kl(6), kq(6), Dev, ikn
Dim sX, E50l, E50q, E30, E40, sNu, sii
Dim x1#, x2#, x3#, x4#, x5#, zz, a, jv, jn
Dim ww, d2, xr, yr, R, s, t, u, V, r1, t0
Dim B#(8), C#(36), grad As Integer
Call Subs("  PolFit " & NUCLIDE(inuc).Nuc)
sErr = "PolFit"
'________________________________________________________________
'************  Ausgleichspolynom ****************** 7.7.93
'________________________________________________________________
grad = 2

funkanf:
  For i = 0 To 6: ko(i) = 0: Next
  GoSub PolCalc
  If (MaxDev > 0.01) And (grad < 6) Then grad = grad + 1: GoTo funkanf
  GoSub PolAus
  GoTo PFEnd

PolCalc:
pol1:: x1# = 0: x2# = 0: x3# = 0: x4# = 0: x5# = 0: ww = 0
  For i = 2 To 8: B#(i) = 0: Next: B#(1) = 1
  For i = 1 To 36: C#(i) = 0: Next: d2 = grad
  For k = 1 To nnn
    xr = xxx(k): yr = yyy(k): B#(2) = xr:
    For i = 2 To d2: B#(i + 1) = B#(i) * xr: Next: B#(d2 + 2) = yr: R = 0
    For i = 1 To d2 + 2
      For j = i To d2 + 2
        R = R + 1: C#(R) = C#(R) + B#(i) * B#(j)
      Next
    Next
    x1# = x1# + xr: x2# = x2# + xr ^ 2: x3# = x3# + yr: x4# = x4# + yr ^ 2
    x5# = x5# + xr * yr
  Next
  If nnn - 1 <= grad Then grad = grad - 1: GoTo pol1
  p = 1: ww = 1: d2 = d2 + 1
  For j = 1 To d2
    If C#(p) > 0 Then
      C#(p) = Sqr(C#(p))
    Else
      MsgBox "PolFit: Calculation impossible": Return
    End If
    For i = 1 To d2 - j + 1
      C#(p + i) = C#(p + i) / C#(p)
    Next
    R = p + i: s = R
    For l = 1 To d2 - j
      p = p + 1
      For M = 1 To d2 + 2 - j - l
        C#(R + M - 1) = C#(R + M - 1) - C#(p) * C#(p + M - 1)
      Next
      R = R + M - 1:
    Next: p = s:
  Next: t = (d2 + 1) * (d2 + 2) / 2
  For i = 1 To d2 - 1: t = t - 1 - i: C#(t) = 1 / C#(t)
    For j = 1 To d2 - i
      p = d2 + 1 - i - j: p = p * (d2 + 1 - (p - 1) / 2) - i
      R = p - j: s = 0: u = i + j + 1: V = p
      For k = 1 To j: V = V + u - k: s = s - C#(R + k) * C#(V): Next
      C#(p) = s / C#(R):
    Next
  Next: C#(1) = 1 / C#(1): t = 0
  For i = 1 To grad + 1: ko(i - 1) = 0
    For j = 1 To grad - i + 2
      R = (i + j - 1) * (d2 + 2 - 0.5 * (i + j))
      ko(i - 1) = ko(i - 1) + C#(t + j) * C#(R)
    Next: t = i * (d2 + (3 - i) / 2)
  Next
  r1 = 0
  For i = 2 To grad + 1
    r1 = r1 + C#(i * (d2 + (3 - i) / 2)) ^ 2
  Next
  t0 = C#((d2 + 1) * (d2 + 2) / 2) - C#(d2 + 1) ^ 2
  QuenchDat(ikb).grad = grad
  For i = 0 To grad
    QuenchDat(ikb).PolKoeff(i) = ko(i)
'Sehr kleine Zahlen zu null setzen
    If Abs(QuenchDat(ikb).PolKoeff(i)) < 10 ^ (-(i * 2 + 3)) Then QuenchDat(ikb).PolKoeff(i) = 0
  Next
  
  
  QuenchDat(ikb).E50 = fnPol(50)
  QuenchDat(ikb).dE1 = 100 * (fnPol(50.5) / fnPol(50) - 1)
  E30 = fnPol(30): E40 = fnPol(40)
  s = 0: MaxDev = 0: sii = ""
  For i = 1 To nnn
    xr = xxx(i): yr = fnPol(xr): zz = yyy(i) - yr: s = s + zz ^ 2
    Dev = Abs(100 * yyy(i) / yr - 100)
    If Dev > MaxDev Then MaxDev = Dev
  Next: x2# = Sqr(s / (nnn - 1))
  ko(grad + 1) = x2#
Return

PolAus:
Return

BisKomma:
  If sX > "" Then ik = InStr(sX, ","): If ik > 0 Then sNu = LTrim$(Left(sX, ik - 1))
Return

'--------------- H i l f s p r o g r a m m e ----------------
Round:
 For j = 1 To 7
   If a * 10 ^ (2 * j) > 1 Then
     a = a * 10 ^ (2 * j)
     sX = Str((2 * j)): sii = "E-" + Right(sX, Len(sX) - 1): Exit For
   End If
 Next
Return

PFEnd:: End Sub

Public Function Quench#(ByVal E)
  Dim c0 As Double, c1 As Double, c2 As Double, c3 As Double, c4 As Double, c5 As Double
  Dim En0, cldiff As Single, z, sA

  If E < 0.0001 Then GoTo QREnd
  Select Case iTypQ
    Case 1: GoSub EffyFormula             'EF
    Case 2: GoSub AGCFormula              'AG
    Case 3: GoSub CIE646Formula           'CI HiS, T, IG
    Case 4: GoSub Pol7Formula             'KB-POL7
    Case 5: z = Log(E): GoSub GrauFormula 'GM1, GM2
    Case 6: GoSub PeSiFormula
  End Select
  GoTo QREnd

EffyFormula: '  Formel von EFFY  (iTypQ=1)
   If E > 10 Then
        Quench# = 1 - 0.9624 * E ^ (-0.5457)
   Else
        Quench# = 0.1253 * Log(E) + 0.4339
   End If
Return

AGCFormula: '  Formel von Agustin Grau Carles (iTypQ=2)
   If E > 10 Then
        Quench# = 1 - 0.8951 * E ^ (-0.5443)
   Else
        Quench# = 0.1217 * Log(E) + 0.4643
   End If
Return

CIE646Formula: '  Formel von Jose Maria Los Arcos CIEMAT 646 HiS2 (iTypQ=3)
    For i = 1 To nKB
      With QuenchDat(i)
        cldiff = Abs(.kBListe - QuenchDat(ikb).rkB)
        If cldiff < 0.00001 Then
          c0 = .Cl(0): c1 = .Cl(1): c2 = .Cl(2): c3 = .Cl(3): c4 = .Cl(4): Exit For
        End If
     End With
   Next
   z = Log(E) / Log(10)
   Quench# = (c0 + c1 * z + c2 * z ^ 2) / (1! + c3 * z + c4 * z ^ 2)
   If Quench# < 0 Then Quench# = 0
   If E > 100 Then Quench# = 1
Return

Pol7Formula: 'Polynomial 7.degree for KB.for
    For i = 1 To nKB
      z = Log(E) / Log(10)
      With QuenchDat(i)
        cldiff = Abs(.kBListe - QuenchDat(ikb).rkB)
        If cldiff < 0.00001 Then
          For k = 0 To 6
            q = q + .Cl(k) * z ^ k
          Next
          Exit For
        End If
     End With
   Next
   Quench# = q
   If Quench# < 0 Then Quench# = 0
   If E > 50 Then Quench# = 1
Return

GrauFormula: '  Formel von A. Grau Malonda (iTypQ=5)
    For i = 1 To nKB
      With QuenchDat(i)
        cldiff = Abs(.kBListe - QuenchDat(ikb).rkB)
        If cldiff < 0.00001 Then
          c0 = .Cl(0): c1 = .Cl(1): c2 = .Cl(2): c3 = .Cl(3): c4 = .Cl(4): c5 = .Cl(5): Exit For
        End If
     End With
   Next
   Quench# = (c0 + c1 * z + c2 * z ^ 2 + c3 * z ^ 3) / (1! + c4 * z + c5 * z ^ 2 + c3 * z ^ 3)
   If Quench# < 0 Then Quench# = 0
   If E > 100 Then Quench# = 1
Return

PeSiFormula: ' >0: PeSiFit-Formel von Fit9/Simpson/Peron  (iTypQ=6)
   En0 = 0.08
   For i = 1 To nKB
     With QuenchDat(i)
      cldiff = Abs(QuenchDat(i).cp(1) - QuenchDat(ikb).rkB)
      If cldiff < 0.00001 Then
        c1 = QuenchDat(i).cp(2): c2 = QuenchDat(i).cp(3): c3 = QuenchDat(i).cp(4)
        c4 = QuenchDat(i).cp(5): c5 = QuenchDat(i).cp(6): c6 = QuenchDat(i).cp(7)
      End If
    End With
   Next
   z = Log(E) / Log(10): Quench# = 1
   If E < 100 Then
       Quench# = c1 + c2 * z + c3 * z ^ 2 + c4 * z ^ 3 + c5 * z ^ 4 + c6 * z ^ 5
   End If
Return
QREnd:: End Function



Public Function EffElek(E)
  Dim x
  q = Quench(E): x = (1 - Exp(-E * q / (2 * 1.2))) ^ 2
  If x < 0.002 Then x = 0
  EffElek = x
End Function

Public Function EffPhot(E)
Dim y
  If E > 1 Then y = 0.00923 * E ^ 4 - 0.309 * E ^ 3 + 2.5 * E ^ 2 + 4.85 * E - 7.12 Else y = 0: '  1-16keV
  If E > 16 Then y = -0.0025947 * E ^ 3 + 0.31756 * E ^ 2 - 13.108 * E + 190.73
  If E > 40 Then y = 0.0000022 * E ^ 3 - 0.00124 * E ^ 2 + 0.216 * E + 1.24: '  40-250 keV
  If E > 300 Then y = 60.6426 * E ^ -0.29596: '  300-2000 keV
  If y < 0.2 Then y = 0
  EffPhot = y / 100
End Function

'************************************************
'
'   Public Sub sleep
'    e.g. call sleep(0.5): wait 0.5 s
'************************************************
Public Sub sleep(ByVal t)
  Dim x
  x = Timer
  Do
    DoEvents
    If Timer - x > t Then Exit Do
  Loop
End Sub

Function RandomGen#()
' ===================================================================
'   RandomGen GENERATES RANDOM NUMBERS
' ===================================================================
   
  Dim i&, k As Long, iz&, ii
  Select Case modu.Random
    Case 1: 'Reads random numbers from a file
        Input #34, RandomGen#: iGen = iGen + 1
        If iGen > 32000 Then
          iGen = 1: Close 34: sFlI34 = sPfdE + "random.dat": Open sFlI34 For Input As #34
        End If
        If modu.Act Then Print #83, iGen & "  " & Format(RandomGen#, "0.0000")
    Case Else:
        If nZuf = 0 Then
          GoSub RNEcuy
        End If
        RandomGen# = RandNum#(nZuf): nZuf = nZuf - 1
  End Select
  GoTo RandomGenEnd
 
RNEcuy:  'Zufallszahlengenerator nach L'Ecuyer
' nZuf=1000: Anzahl Zufallszahlen
' u(1..n)Feld der Zufallszahlen.
'1 000 000 Zahlen in 4 s ohne, in 27 s mit Speicherung (21 MB)
  nZuf = 1000
  For i& = 1 To nZuf
    k = iSeed1& / IQ1& ' Produce integer random number x1 from first MLCG
    iSeed1& = IA1& * (iSeed1& - k * IQ1&) - k * ir1&
    If iSeed1& < 0 Then iSeed1& = iSeed1& + M1&
    k = iSeed2& / IQ2& ' Produce integer random number x2 from second MLCG
    iSeed2& = IA2& * (iSeed2& - k * IQ2&) - k * ir2&
    If iSeed2& < 0 Then iSeed2& = iSeed2& + M2&
    iz& = iSeed1& - iSeed2& 'Combine
    If iz& < 1 Then iz& = iz& + M1Min1&
    RandNum#(i&) = iz& * XM1inv 'Normalize and transform to floating point
  Next
Return

RandomGenEnd:: End Function




Public Sub RandomGenStart()
  iSeed1& = 123456: iSeed2& = 654321
End Sub
